"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducer = void 0;

var constants = _interopRequireWildcard(require("../constants"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var sessionReplayTimerDelay = sessionStorage.getItem(constants.sessionReplayTimerDelayKey);
var initialState = {
  logEntries: [],
  highlightedIndex: null,
  replayTimerId: null,
  replayTimerDelay: sessionReplayTimerDelay ? +sessionReplayTimerDelay : constants.delayValues[1]
};

var reducer = function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  // console.log('reducing', action, state);
  switch (action.type) {
    case 'ADD_LOG_ENTRY':
      {
        var componentName = action.componentName,
            instanceId = action.instanceId,
            methodName = action.methodName;
        return _objectSpread({}, state, {
          logEntries: [].concat(_toConsumableArray(state.logEntries), [{
            componentName: componentName,
            instanceId: instanceId,
            methodName: methodName
          }])
        });
      }

    case 'CLEAR_LOG_ENTRIES':
      {
        return _objectSpread({}, state, {
          logEntries: []
        });
      }

    case 'SET_HIGHLIGHT':
      {
        return _objectSpread({}, state, {
          highlightedIndex: action.highlightedIndex
        });
      }

    case 'SET_REPLAY_TIMER_ID':
      {
        return _objectSpread({}, state, {
          replayTimerId: action.replayTimerId
        });
      }

    case 'SET_REPLAY_TIMER_DELAY':
      {
        return _objectSpread({}, state, {
          replayTimerDelay: action.replayTimerDelay
        });
      }

    default:
      {
        return state;
      }
  }
};

exports.reducer = reducer;